Index: plugins/importExport/inc/flat/class.backupFile.php
===================================================================
--- plugins/importExport/inc/flat/class.backupFile.php	(revision 270)
+++ plugins/importExport/inc/flat/class.backupFile.php	(revision 270)
@@ -0,0 +1,133 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+class backupFile
+{
+	protected $fp;
+	private $line_cols = array();
+	private $line_name;
+	
+	private $replacement = array(
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\n)/u' => "\$1\n",
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\r)/u' => "\$1\r",
+		'/(?<!\\\\)(?>(\\\\\\\\)*+)(\\\\")/u' => '$1"',
+		'/(\\\\\\\\)/' => '\\'
+	);
+	
+	public function __construct($file)
+	{
+		if (file_exists($file) && is_readable($file)) {
+			$this->fp = fopen($file,'rb');
+		} else {
+			throw new Exception(__('No file to read.'));
+		}
+	}
+	
+	public function __destruct()
+	{
+		if ($this->fp) {
+			fclose($this->fp);
+		}
+	}
+	
+	public function getLine()
+	{
+		if (feof($this->fp)) {
+			return false;
+		}
+		
+		$line = trim(fgets($this->fp));
+		
+		if (substr($line,0,1) == '[')
+		{
+			$this->line_name = substr($line,1,strpos($line,' ')-1);
+			
+			$line = substr($line,strpos($line,' ')+1,-1);
+			$this->line_cols = explode(',',$line);
+			
+			return $this->getLine();
+		}
+		elseif (substr($line,0,1) == '"')
+		{
+			$line = preg_replace('/^"|"$/','',$line);
+			$line = preg_split('/(^"|","|"$)/m',$line);
+			
+			if (count($this->line_cols) != count($line)) {
+				throw new Exception('Invalid row count');
+			}
+			
+			$res = array();
+			
+			for ($i=0; $i<count($line); $i++) {
+				$res[$this->line_cols[$i]] =
+				preg_replace(array_keys($this->replacement),array_values($this->replacement),$line[$i]);
+			}
+			
+			return new backupFileItem($this->line_name,$res);
+		}
+		else
+		{
+			return $this->getLine();
+		}
+	}
+}
+
+class backupFileItem
+{
+	public $__name;
+	private $__data = array();
+	
+	public function __construct($name,$data)
+	{
+		$this->__name = $name;
+		$this->__data = $data;
+	}
+	
+	public function f($name)
+	{
+		return iconv('UTF-8','UTF-8//IGNORE',$this->__data[$name]);
+	}
+	
+	public function __get($name)
+	{
+		return $this->f($name);
+	}
+	
+	public function __set($n,$v)
+	{
+		$this->__data[$n] = $v;
+	}
+	
+	public function exists($n)
+	{
+		return isset($this->__data[$n]);
+	}
+	
+	public function drop()
+	{
+		foreach (func_get_args() as $n) {
+			if (isset($this->__data[$n])) {
+				unset($this->__data[$n]);
+			}
+		}
+	}
+	
+	public function substitute($old,$new)
+	{
+		if (isset($this->__data[$old])) {
+			$this->__data[$new] = $this->__data[$old];
+			unset($this->__data[$old]);
+		}
+	}
+}
+?>
Index: plugins/importExport/inc/flat/class.db.export.php
===================================================================
--- plugins/importExport/inc/flat/class.db.export.php	(revision 270)
+++ plugins/importExport/inc/flat/class.db.export.php	(revision 270)
@@ -0,0 +1,106 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+class dbExport
+{
+	private $con;
+	private $prefix;
+	
+	private $line_reg = array('/\\\\/u',  '/\n/u','/\r/u','/"/u');
+	private $line_rep = array('\\\\\\\\', '\n'   ,'\r'   ,'\"');
+	
+	public $fp;
+	
+	function __construct($con,$out='php://output',$prefix=null)
+	{
+		$this->con =& $con;
+		$this->prefix = $prefix;
+		
+		if (($this->fp = fopen($out,'w')) === false) {
+			return false;
+		}
+		@set_time_limit(300);
+	}
+	
+	function __destruct()
+	{
+		if (is_resource($this->fp)) {
+			fclose($this->fp);
+		}
+	}
+	
+	function export($name,$sql)
+	{
+		$rs = $this->con->select($sql);
+		
+		if (!$rs->isEmpty())
+		{
+			fwrite($this->fp,"\n[".$name.' '.implode(',',$rs->columns())."]\n");
+			while ($rs->fetch()) {
+				fwrite($this->fp,$this->getLine($rs));
+			}
+			fflush($this->fp);
+		}
+	}
+	
+	function exportAll()
+	{
+		$tables = $this->getTables();
+		
+		foreach ($tables as $table)
+		{
+			$this->exportTable($table);
+		}
+	}
+	
+	function exportTable($table)
+	{
+		$req = 'SELECT * FROM '.$this->con->escapeSystem($this->prefix.$table);
+		
+		$this->export($table,$req);
+	}
+	
+	function getTables()
+	{
+		$schema = dbSchema::init($this->con);
+		$db_tables = $schema->getTables();
+		
+		$tables = array();
+		foreach ($db_tables as $t)
+		{
+			if ($this->prefix) {
+				if (strpos($t,$this->prefix) === 0) {
+					$tables[] = $t;
+				}
+			} else {
+				$tables[] = $t;
+			}
+		}
+		
+		return $tables;
+	}
+	
+	function getLine($rs)
+	{
+		$l = array();
+		$cols = $rs->columns();
+		foreach ($cols as $i => &$c) {
+			$s = $rs->f($c);
+			$s = preg_replace($this->line_reg,$this->line_rep,$s);
+			$s = '"'.$s.'"';
+			$l[$i] = $s;
+		}
+		return implode(',',$l)."\n";
+	}
+}
+?>
